use eframe::egui::{Response, Ui, Widget};

use super::state::AppState;

pub struct PromptInput<'a> {
    app_state: &'a mut AppState,
}

impl<'a> PromptInput<'a> {
    pub fn new(app_state: &'a mut AppState) -> Self {
        Self { app_state }
    }
}

impl<'a> Widget for PromptInput<'a> {
    fn ui(self, ui: &mut Ui) -> Response {
        let label = ui.label("Prompt:");
        ui.text_edit_multiline(&mut self.app_state.prompt_input)
            .labelled_by(label.id);

        ui.horizontal(|ui| {
            if ui.button("Submit").clicked() {
                futures::executor::block_on(self.app_state.handle_submission());
            }

            if ui.button("Clear").clicked() {
                self.app_state.prompt_input.clear();
            }
        })
        .response
    }
}
